/* 
	ListAccounts.java
	
  <http://www.stalker.com/CGJava>

*/

//package ListAccounts;

import java.awt.*;
import java.awt.event.*;
import java.applet.*;
import java.lang.*;

import java.util.Vector;
import java.util.Hashtable;
import java.util.Enumeration;

import com.stalker.CGPro.*;


public class ListAccounts extends Applet 
{

// BEGIN GENERATED CODE
	// member declarations
	java.awt.Label lbHost = new java.awt.Label();
	java.awt.TextField tfHost = new java.awt.TextField();
	java.awt.Label lbdomain = new java.awt.Label();
	java.awt.TextField tfDomain = new java.awt.TextField();
	java.awt.Label lbPassword = new java.awt.Label();
	java.awt.TextField tfPassword = new java.awt.TextField();
	java.awt.Button btGetAcocunts = new java.awt.Button();
	java.awt.List lsAccounts = new java.awt.List();
	java.awt.Label lbError = new java.awt.Label();
// END GENERATED CODE

	boolean isStandalone = false;

	public ListAccounts() 
	{
	}

	// Retrieve the value of an applet parameter
	public String getParameter(String key, String def) 
	{
		return isStandalone ? System.getProperty(key, def) :
			(getParameter(key) != null ? getParameter(key) : def);
	}

	// Get info on the applet parameters
	public String[][] getParameterInfo() 
	{
		return null;
	}

	// Get applet information
	public String getAppletInfo() 
	{
		return "Applet Information";
	}

	// Initialize the applet
	public void init() 
	{
		try {
			initComponents();
		}
		catch (Exception e) {
			e.printStackTrace();
		}
	}

	public void initComponents() throws Exception
	{
// BEGIN GENERATED CODE
		// the following code sets the frame's initial state
		lbHost.setText("CGPro host:");
		lbHost.setLocation(new java.awt.Point(10, 10));
		lbHost.setVisible(true);
		lbHost.setSize(new java.awt.Dimension(60, 20));

		tfHost.setLocation(new java.awt.Point(70, 10));
		tfHost.setVisible(true);
		tfHost.setSize(new java.awt.Dimension(320, 20));

		lbdomain.setText("Domain:");
		lbdomain.setLocation(new java.awt.Point(10, 40));
		lbdomain.setVisible(true);
		lbdomain.setSize(new java.awt.Dimension(60, 20));

		tfDomain.setLocation(new java.awt.Point(70, 40));
		tfDomain.setVisible(true);
		tfDomain.setSize(new java.awt.Dimension(320, 20));

		lbPassword.setText("Admin Password:");
		lbPassword.setLocation(new java.awt.Point(10, 70));
		lbPassword.setVisible(true);
		lbPassword.setSize(new java.awt.Dimension(90, 20));

		tfPassword.setLocation(new java.awt.Point(100, 70));
		tfPassword.setVisible(true);
		tfPassword.setSize(new java.awt.Dimension(290, 20));

		btGetAcocunts.setLocation(new java.awt.Point(260, 100));
		btGetAcocunts.setLabel("Get Accounts List");
		btGetAcocunts.setVisible(true);
		btGetAcocunts.setSize(new java.awt.Dimension(130, 20));

		lsAccounts.setLocation(new java.awt.Point(10, 130));
		lsAccounts.setVisible(false);
		lsAccounts.setSize(new java.awt.Dimension(380, 180));

		lbError.setText("Error:");
		lbError.setLocation(new java.awt.Point(10, 130));
		lbError.setVisible(false);
		lbError.setSize(new java.awt.Dimension(380, 70));

		setLocation(new java.awt.Point(0, 0));
		setLayout(null);
		setSize(new java.awt.Dimension(405, 320));
		add(lbHost);
		add(tfHost);
		add(lbdomain);
		add(tfDomain);
		add(lbPassword);
		add(tfPassword);
		add(btGetAcocunts);
		add(lsAccounts);
		add(lbError);


		btGetAcocunts.addActionListener(new java.awt.event.ActionListener() {
			public void actionPerformed(java.awt.event.ActionEvent e) {
				btGetAcocuntsAction(e);
			}
		});
// END GENERATED CODE
    tfPassword.setEchoChar('*');
	}
	
	public void btQuitAction(java.awt.event.ActionEvent e) {
	  java.lang.System.exit(0);
	}
	
	void showError(String message) {
	  lbError.setForeground(Color.red);
	  lbError.setText("Error. "+message);
	  lsAccounts.hide();
	  lbError.show();
	  System.out.println("Error. "+message);	  
	}
	
	public void btGetAcocuntsAction(java.awt.event.ActionEvent evt) {
    String host=tfHost.getText();
    String domain=tfDomain.getText();
    String password=tfPassword.getText();
    CGProCLI cli;

	  try {
      cli= new CGProCLI(host,106,"postmaster",password);
      try {
        Hashtable accounts=cli.listAccounts(domain);
        lsAccounts.removeAll(); 
        for (Enumeration e = accounts.keys() ; e.hasMoreElements() ;) {
          Object o=e.nextElement();
          lsAccounts.add((String)o);
        }
     	  lbError.hide();
     	  lsAccounts.show();

      } catch(CGProException e) {
        showError(e.getMessage());
      }
      
      cli.logout();
    } catch(CGProException e) {
      showError(e.getMessage());
    } catch(Exception e) {
      showError(e.getMessage());
      e.printStackTrace();
    }

	}

}
